# Iterative Spectral Method ( ISM ) 

Iterative Spectral Method (ISM) was originally proposed in the paper 
*Iterative Spectral Method for Alternative Clustering*, Wu et al., AISTATS 2018. 
It is an optimization technique that could be used to solve many HSIC related problems with a 
Gaussian Kernel. This version is written as an easy extension to other kernels. 


## Getting Started

The code is written with python3 on a Mint Linux Machine version 17.1. 
The following libraries must be included.

  1. numpy
  2. matplotlib
  3. sklearn
  4. scipy


## How to Run
 Just run ./sdr.py to see it in action. 



## License
This project is licensed under the MIT License - see the [LICENSE.md](https://github.com/neu-spiral/ISM/blob/master/LICENSE) file for details

## Download Paper
https://arxiv.org/abs/1909.03093


## Citation
If you intend to use our code in your research, please cite our paper as follows:
```
@inproceedings{wu2017ISM,
  title={Iterative Spectral Method for Alternative Clustering},
  author={Wu, Chieh and Ioannidis, Stratis and Mario, Sznaier and Xiangyu, Li and David, Kaeli and Jennifer, Dy},
  booktitle={Artificial Intelligence and Statistics},
  year={2018}
}
```
and


## Contributors

* **Chieh Wu** , **Jared Miller** , **Mario Sznaier** , **Yale Chang** , **Jennifer Dy**

## Acknowledgments

We would like to acknowledge support for this project from the NSF grant IIS-1546428.
